#!/usr/bin/perl -w

use strict;
use CGI; # Modul fuer CGI-Programme

my $cgi = new CGI; # neues Objekt erstellen
my $Passwd = $cgi->param("passwd");
my $status = $cgi->param("status");
my $irmodule = $cgi->param("IRID");
my $batteryStatus = $cgi->param("BATTERY");
my $stream = $cgi->param("STREAM");
my $file_command = "R7command.txt";
my $previous_file_command = "previousR7command.txt";
my $file_access = "R7access.txt";
my $command_line = "";
my $drive_distance = 0;
my $total_drive_distance = 0;
my $total_user_count = 0;
my ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time);
my $CTIME_String = localtime(time);
my @file_info;
my $current_user = "";
my $current_ip = "";
my $current_timestamp = "";
my $char_temp = "";
my $file_server_status = "R7-connect.txt";
my $last_snapshot_name = "";
my $first_access_time = "";



if(!$Passwd){
  $Passwd = "";
}
if(!$status){
  $status = "";
}
if(!$irmodule){
  $irmodule = 0;
}
if(!$batteryStatus){
  $batteryStatus = 0;
}

# Content-type fuer die Ausgabe
print $cgi->header(-type => 'text/html');


#print "Passwd=-" . $Passwd . "-\n";

if($Passwd ne "YOURPASSWORD"){
  print "Wrong passwd";
  exit(0);
}

open(FILEOUT, "> LastCallFromRover.txt") || die "Can not open file LastCallFromRover.txt!\n";
close(FILEOUT);

open(FILEOUT, "> BatteryStatus.txt") || die "Can not open file BatteryStatus.txt!\n";
  print FILEOUT $batteryStatus . "\n";
close(FILEOUT);

if(-e "LostConnection.bmp"){
  `rm LostConnection.bmp -f`;
}


if(-e $file_server_status){
  `rm $file_server_status`;
  `cp connection_established.jpg bild01.jpg`;
  `cp last_transmitted.jpg bild01.jpg`;
  &CopyIndicationPicture();
  `mv $file_command $previous_file_command`;
  open(FILEOUT, ">" . $file_access) || die "Can not open file " . $file_command . "!\n";
  close(FILEOUT);
  `rm *-CurrentUser.bmp -f`;
  `rm hidden/*.usr -f`;
  `rm hidden/*-CurrentUser.bmp -f`;
  `cp R7Free.xxx R7Free.bmp`;
}

if($status eq "FirstStart"){
  `mv $file_command $previous_file_command`;
  open(FILEOUT, ">" . $file_access) || die "Can not open file " . $file_command . "!\n";
  close(FILEOUT);
  LogFile("Received FirstStart command.");
  `rm *-CurrentUser.bmp -f`;
  `rm hidden/*.usr -f`;
  `rm hidden/*-CurrentUser.bmp -f`;
  `cp R7Free.xxx R7Free.bmp`;
  if(!(-e "RoverCommand.bmp")){
    `cp IndicationPicture01.bmp RoverCommand.bmp`;
  }
}

if($status eq "finished"){
  `mv $file_command $previous_file_command`;
}


if($status eq "FinishedAll"){
  if (-e $previous_file_command){#If command in pipline, get stats
    open(FILEIN, "<" . $previous_file_command) || die "Can not open file " . $previous_file_command . "!\n";
      $command_line = <FILEIN>;
    close(FILEIN);
    $current_user = substr($command_line, 60, 20);
    $current_ip = substr($command_line, 40, 20);
    $current_timestamp = substr($command_line, 20, 20);
  }
  `mv $file_command $previous_file_command`;

  open(DATEIIN, '<'.$file_access) || die 'File ' .  $file_access . ' not found, please try again.</td></tr></table></body></html>';
    $first_access_time = <DATEIIN>;
  close (DATEIIN);
  $first_access_time = substr($first_access_time, 60, 20);

  open(FILEOUT, ">" . $file_access) || die "Can not open file " . $file_command . "!\n";
  close(FILEOUT);
  `rm *-CurrentUser.bmp -f`;
  `rm hidden/*.usr -f`;
  `rm hidden/*-CurrentUser.bmp -f`;
  `cp R7Free.xxx R7Free.bmp`;


  if (-e "last-snapshot.txt"){
    open(FILEIN, "< last-snapshot.txt") || die "Can not open file last-snapshot.log!\n";
      $last_snapshot_name = <FILEIN>;
    close (FILEIN);
    open(FILEOUT, "> last-snapshot.txt") || &LogFile("Can not open file last-snapshot.txt!");
      print FILEOUT "";
    close(FILEOUT);
  }
  else{
    &LogFile ("Could not find access-count.log.");
  }

  @file_info = stat("access-history.log");
  if ($file_info[7] > 10000000){
    `mv access-history.log access-history01.log`;
  }
  $last_snapshot_name = substr($last_snapshot_name . "                    ", 0, 20);
  open(FILEOUT, ">> access-history.log") || die "Can not open file access-history.log!\n";
    print FILEOUT $current_user . $current_ip . $current_timestamp . $last_snapshot_name . $first_access_time . "_\n";
  close(FILEOUT);

  if (-e "access-count.log"){
    open(FILEIN, "< access-count.log") || die "Can not open file access-count.log!\n";
      $total_user_count = <FILEIN>;
      $total_drive_distance = <FILEIN>;
    close (FILEIN);
  }
  else{
    &LogFile ("Could not find access-count.log.");
  }

  $total_user_count++;
  $total_drive_distance += 0; # Or else it is treated as string with CRLF while saving
  open(FILEOUT, "> access-count.tmp") || die "Can not open file access-count.tmp!\n";
    print FILEOUT $total_user_count . "\n";
    print FILEOUT $total_drive_distance . "\n";
  close(FILEOUT);

  `cp access-count.tmp access-count.log`;

}


if($status eq "waiting"){
  if (-e $file_command){#If command in pipline, start processing
    open(FILEIN, "<" . $file_command) || die "Can not open file " . $file_command . "!\n";
      $command_line = <FILEIN>;
    close(FILEIN);

    $current_user = substr($command_line, 60, 20);
    $current_ip = substr($command_line, 40, 20);
    $current_timestamp = substr($command_line, 20, 20);

    $command_line = substr("Comm=" . $command_line, 0, 20);

    $drive_distance = substr($command_line, 7, 2);
    if($drive_distance < 0 || $drive_distance > 200){
      &LogFile ("drive_distance=$drive_distance out of range!");
      $drive_distance = 0;
    }

    if (-e "access-count.log"){
      open(FILEIN, "< access-count.log") || die "Can not open file access-count.log!\n";
        $total_user_count = <FILEIN>;
        $total_drive_distance = <FILEIN>;
      close (FILEIN);
    }
    else{
      &LogFile ("Could not find access-count.log.");
    }
    $total_user_count += 0;  # Or else it is treated as string with CRLF while saving
    $total_drive_distance += $drive_distance * 1.4;
    open(FILEOUT, "> access-count.tmp") || die "Can not open file access-count.tmp!\n";
      print FILEOUT $total_user_count . "\n";
      print FILEOUT $total_drive_distance . "\n";
    close(FILEOUT);

    `cp access-count.tmp access-count.log`;

    if($command_line ne "Comm="){
      print $command_line;  #$client_socket->send($command_line, 20);
    }
    else{
      print "no job available";
      &LogFile("Empty command line in file '" . $file_command . "'");
    }
  }
  else{
    if(glob("hidden/*.usr") && time() - (stat("access-count.log"))[9] > 90){#90 seconds without a transmitted command while rover in use? That should not happen...
      open(FILEOUT, ">" . $file_access) || die "Can not open file " . $file_command . "!\n";
      close(FILEOUT);
      `rm *-CurrentUser.bmp -f`;
      `rm hidden/*.usr -f`;
      `rm hidden/*-CurrentUser.bmp -f`;
    }
    print "no job available";
    if(!(-e "RoverCommand.bmp")){
      `cp IndicationPicture01.bmp RoverCommand.bmp`;
    }
  }
}

if($stream == 4){
  &CopyIndicationPicture();
}



&WatchDogFile();

#++++++++++++++++++++++ Copy indication for new picture +++++++++++++++++++++++++++++++++
sub CopyIndicationPicture{
  #There are 9 (very small) indication pictures (IndicationPicture01 - IndicationPicture09) stored at the server.
  #The width of those pictures alteres fom 1 to 9 pixel.
  #If a new picture from the R7 has been transmitted, CurentIndicationPicture is altered.
  #The Javascript of your browser compares the old width of CurentIndicationPicture with the new one, to indicate that a new R7 pic is at the server.
  #This keeps the transferrate of the picture download to your browser low.

  my $last_indication_pic_no = 0;

  if(!-e "CurrentIndicationPicture.txt"){
    $last_indication_pic_no = 1;
  }
  else{
    open(FILEIN, "< CurrentIndicationPicture.txt") || die &LogFile("Watchdog: Can not open file CurrentIndicationPicture.txt!");
      $last_indication_pic_no = <FILEIN>;
    close(FILEIN);
  }

  `cp IndicationPicture0$last_indication_pic_no.bmp CurrentIndicationPicture.bmp`;
  $last_indication_pic_no++;
  if($last_indication_pic_no == 10){
    $last_indication_pic_no = 1;
  }

  open(FILEOUT, "> CurrentIndicationPicture.txt") || die "Can not open file CurrentIndicationPicture.txt!\n";
    print FILEOUT $last_indication_pic_no;
  close (FILEOUT);
}


#++++++++++++++++++++++ LogFile +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub LogFile{

  @file_info=stat("R7-server.log");

  ($seconds, $minutes, $hours, $day_of_month, $month, $year, $weekday, $day_of_year, $summertime) = localtime(time());

  if ($hours < 10){
    $hours = "0" . $hours;
  }
  if ($minutes < 10){
    $minutes = "0" . $minutes;
  }
  if ($seconds < 10){
    $seconds = "0" . $seconds;
  }
  $month += 1;
  $year += 1900;

  if ($month < 10){
    $month = "0" . $month;
  }
  if ($day_of_month < 10){
    $day_of_month = "0" . $day_of_month;
  }

  $char_temp=substr($day_of_month . "." . $month . "." . $year . "-" . $hours . ":" . $minutes . ":" . $seconds . "                    ", 0, 20);

  if ($file_info[7] > 1000000){
    `mv R7-server.log R7-server01.log`
  }

  open(LOGFILE, ">> R7-server.log") || die "Can not open file 'R7-server.log'!\n";
    print LOGFILE $char_temp . $_[0] . "\n";
  close(LOGFILE);

}

#++++++++++++++++++++++ WatchDogFile +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
sub WatchDogFile{#Print a timestamp into a file to show watchdog-server.perl that script is still alive
#  if(time() - $last_watchdog_call > 10){
    open(WATCHDOGFILE, "> watchdog.tmp") || die "Can not open file 'watchdog.tmp'!\n";
      print WATCHDOGFILE time() . "\n";
    close(WATCHDOGFILE);
#    if($_[0] == 0){
      `mv watchdog.tmp watchdog.txt`;
#    }
#    $last_watchdog_call = time();
#  }
}

