#!/bin/bash

cd /ram0/R7

killall -s SIGKILL raspistill
killall -s SIGKILL raspivid
#killall -s SIGKILL mjpg_streamer
killall -s SIGKILL ffserver
killall -s SIGKILL ffmpeg



#rm /ram0/webcam.ffm
ffserver -d -f /etc/ffserver.conf&
sleep 1

#Automatic Raspberry camera adjustments
raspivid -hf -vf -w 320 -h 240 -t 0 -fps 5 -b 70000 -n --awb auto -o - | ffmpeg  -f h264 -r 5 -i - -vcodec mjpeg -pix_fmt yuvj420p -s 320x240 -r 5 -an http://192.168.2.17:8017/webcam.ffm&
#Outdoor Raspberry camera adjustments
#raspivid -hf -w 320 -h 240 -t 0 -fps 5 -b 70000 -n --awb auto --ISO 100 -ex night -ss 2000 -o - | ffmpeg  -f h264 -r 5 -i - -vcodec mjpeg -pix_fmt yuvj420p -s 320x240 -r 5 -an http://192.168.2.15:8015/webcam.ffm&
#Indoor Raspberry camera adjustments
#raspivid -hf -w 320 -h 240 -t 0 -fps 5 -b 70000 -n --awb auto --ISO 800 -br 70 -co 70 -ex night -ss 20000 -o - | ffmpeg  -f h264 -r 5 -i - -vcodec mjpeg -pix_fmt yuvj420p -s 320x240 -r 5 -an http://192.168.2.15:8015/webcam.ffm&


